
-- blasts the hud
-- so it looks like sonic blast
-- but better looking ig!!

-- the act numbers from 4 to 9 (and 0) are custom made
-- they were made by sludesus!!! :D

local cachedPatches = {}
-- fixed the lag that title card caused to me
-- so it's automatically very cool!!
local function getPatch(v, patch)
	if not (cachedPatches[patch] and cachedPatches[patch].valid) then
		cachedPatches[patch] = v.cachePatch(patch)
	end
	return cachedPatches[patch]
end

local musName
local prevMapmusname

sfxinfo[freeslot("sfx_sbhusf")].caption = "Hurry Up!"
sfxinfo[freeslot("sfx_sbtiup")].caption = "Time's Ending!"
sfxinfo[freeslot("sfx_sbcndw")].caption = "Get out of there!"
local hurryupTime = 35*TICRATE

addHook("PlayerSpawn", function(p)
	if prevMapmusname then
		mapmusname = prevMapmusname
		prevMapmusname = nil
		if musName ~= mapmusname then
			P_RestoreMusic(p)
		end
	end
end)

rawset(_G, "BlastCountdown", {
	pvars = {}, -- for player variables, preferably add it to the end of the list!! (this is a numbered list :P)
	gvars = {}, -- for global variables !!, should use the same numbered form as pvars
	maps = { -- for map-specific stuff, used for BCZ1 :D, uses Name+act, so BCZ1 = "Black Core 1"
		["Black Core 1"] = 60*TICRATE+35*TICRATE, -- 1:35
	}
}) -- allows custom stuff to add a countdown !!

local function getCountdown(p, lvlonly)
	local mh = mapheaderinfo[gamemap]
	if max(mh.countdown*TICRATE, 0) > 0 then
		return max(mh.countdown*TICRATE, 0)
	end
	
	if BlastCountdown.maps[mh.lvlttl+" "+mh.actnum] then
		return BlastCountdown.maps[mh.lvlttl+" "+mh.actnum]
	end
	
	if lvlonly then return 0 end
	
	for _, val in ipairs(BlastCountdown.pvars) do
		if type(p[val]) == "number" and p[val] > 0 then
			return p[val]
		end
	end
	
	-- global variables!!
	for _, val in ipairs(BlastCountdown.gvars) do
		if type(val) == "number" and val > 0 then
			return val
		end
	end
	
	return 0
end

addHook("HUD", function(v, p)
	if G_IsSpecialStage() then return end
	
	local patch, flip = v.getSpritePatch(SPR_RING, leveltime%(X+1), 0)
	flip = $ and V_FLIP or 0
	
	local scale = FU/2
	v.drawScaled(5*FU+patch.leftoffset*scale, 5*FU+patch.topoffset*scale, scale, patch, V_PERPLAYER|V_HUDTRANS|flip)
	
	v.drawPaddedNum(40, 10, p.rings, 2, V_PERPLAYER|V_HUDTRANS)
	
	--local countdown = max(mapheaderinfo[gamemap].countdown*TICRATE, 0) -- making sure :P
	local countdown = getCountdown(p)
	if countdown < hurryupTime+10*TICRATE -- have ATLEAST 40 secs of a time limit to show the HURRY UP! thingie
	or p.exiting then return end -- and the level isn't exiting yet :P
	local timeleft = countdown-p.realtime
	
	if timeleft > hurryupTime then return end
	
	if (musName == mapmusname:upper() or musName == "" or musName == " ") -- making sure :P
	and mapmusname ~= ""
	and timeleft <= hurryupTime-(TICRATE+TICRATE/2) then
		S_ChangeMusic("SBHUUP", false)
		prevMapmusname = mapmusname
		mapmusname = ""
	end
	
	if timeleft <= hurryupTime-(21*TICRATE+TICRATE/2)
	and musName ~= "SBACTS" then
		S_StopMusic(p) -- NO MUSIC ALLOWED from now on
		-- but allow the act start music :D
	end
	
	if timeleft < hurryupTime-(24*TICRATE+TICRATE/2) then
		if timeleft%TICRATE == 0 then
			S_StartSound(p.mo, sfx_sbcndw, p)
		end
		return
	end
	
	local patch = getPatch(v, "BLASTHURRYUP")
	local dupx = ((v.width()*FU)-(320*FU*v.dupx()))/v.dupx() -- MATH !!
	
	if timeleft <= hurryupTime-(21*TICRATE+TICRATE/2) then -- tbh this is even more scuffed :P
		timeleft = $-(hurryupTime-(24*TICRATE+TICRATE/2)) -- should be 3 secs at its highest value :P
		
		if timeleft%(TICRATE/2) == 0 then
			S_StartSound(p.mo, sfx_sbtiup, p)
		end
		
		local remainder = timeleft%(3*TICRATE+1)/TICRATE
		local dupy = ((v.height()*FU)-(200*FU*v.dupy()))/v.dupy() -- MATH !! but vertical
		local txease = ease.linear(FixedDiv(timeleft-remainder*TICRATE, TICRATE), -patch.width*FU, 320*FU+dupx)
		local yease = ease.linear(FixedDiv(remainder, 2), 200*FU+dupy-32*FU, 32*FU)  -- i loev ease.linear !!
		
		v.drawScaled(txease, yease-patch.height*(FU/2), FU, patch, V_PERPLAYER|V_HUDTRANS)
		return
	end
	
	-- this is pretty scuffed ngl :P
	-- BUT, it works!! :D
	timeleft = $-(hurryupTime-2*TICRATE)
	if timeleft < 0 then return end -- don't do all of this stuff if you're not supposed to show anyways :P
	
	local tmath = min(max(FixedDiv(timeleft-(TICRATE+TICRATE/2), TICRATE/2), 0), FU)
	local arg2 = 320*FU+dupx
	local arg1 = arg2/2-patch.width*(FU/2)
	if timeleft <= TICRATE/2 then
		tmath = min(max(FixedDiv(timeleft, TICRATE/2), 0), FU)
		arg2 = arg1
		arg1 = -patch.width*FU
	elseif timeleft%(TICRATE/2) == 0 then
		S_StopMusic(p)
		S_StartSound(p.mo, sfx_sbhusf, p)
	end
	local xease = ease.linear(tmath, arg1, arg2)
	v.drawScaled(xease, 100*FU-patch.height*(FU/2), FU, patch, V_PERPLAYER|V_HUDTRANS)
end)

local function drawScaledLevelTitle(v, x, y, scale, str, flags, colormap, bypass) -- somewhat scuffed, but im using this for freakin sonic blast hud i dont need to make it good
	if v == nil
	or str == nil then return end
	
	x = $ ~= nil and $ or 0
	y = $ ~= nil and $ or 0
	scale = $ ~= nil and $ or FU
	flags = $ ~= nil and $ or 0
	colormap = $ ~= nil and $ or v.getColormap(0, 0)
	
	local dupx = ((flags & V_NOSCALESTART) and not bypass) and v.dupx() or 1
	local ux = x
	local chars = {}
	for i = 1, string.len(str) do
		local curLtr = string.byte(string.sub(str, i, i))
		
		local font = curLtr < 100 and "LTFNT0" or "LTFNT"
		if not v.patchExists(font+curLtr)
		--and curLtr ~= string.byte(" ") then
			if curLtr == string.byte(" ") then
				ux = $-(16*scale*dupx)/2
			else
				continue
			end
		end
		
		local patch = getPatch(v, font+curLtr)
		if curLtr ~= string.byte(" ")
			ux = $-(patch.width*scale*dupx)/2
		end
		table.insert(chars, {curLtr, patch})
	end
	
	for _, t in ipairs(chars) do
		if t[1] == string.byte(" ") then
			ux = $+16*scale*dupx
			continue
		end
		
		v.drawScaled(ux, y, scale, t[2], flags, colormap)
		ux = $+t[2].width*scale*dupx
	end
end

local function drawBlastNum(v, x, y, scale, num, flags, align, font)
	if v == nil
	or tonumber(num) == nil then return end
	
	x = $ ~= nil and $ or 0
	y = $ ~= nil and $ or 0
	scale = $ ~= nil and $ or FU
	num = tostring($)
	flags = $ ~= nil and $ or 0
	align = $ ~= nil and $ or "right"
	font = $ ~= nil and $ or "BLASTNUM"
	
	local len = string.len(num)
	
	for i = 1, len do
		--local curNum = string.lower(align) ~= "left" and string.sub(num, i, i) or string.sub(num, len+i, len+i)
		local curNum = string.sub(num, i, i)
		local mul = 1
		if string.lower(align) == "left"
			curNum = string.sub(num, len-(i-1), len-(i-1))
			mul = -1
		end
		
		local patch = getPatch(v, font+curNum)
		v.drawScaled(x+(patch.width+1)*i*scale*mul, y, scale, patch, flags)
	end
end

-- the stuff below are all in the order they were made
-- except the fade, that has to be below everything
-- so i placed it at the top, it was made after the
-- title card bg stuff alright??? end of comment :)
--											-Pacola

addHook("HUD", function(v, p, tics, endt)
	if tics >= endt then return end
	
	if tics == 1
		S_ChangeMusic("SBACTS", false, p)
		S_StartMusicCaption("Act Start!", endt-2, p)
	end
	
	-- the fade, so it fades the lvl back on the end!!
	-- like sonic blast released for the Game Gear
	local fadestr = FixedRound(ease.linear(max(FixedDiv(tics-(endt-TICRATE/2), endt-(endt-TICRATE/2)), 0), 31*FU, 0))/FU
	v.fadeScreen(0xFF00, min(fadestr, 31))
	
	-- title card background stuff
	-- anything that isn't the text
	local xpos = ease.linear(min(FixedDiv(tics, 20), FU), 0, v.width()*FU)-v.width()*FU -- math
	local ypos = ease.linear(max(FixedDiv(tics-80, endt-80-(TICRATE-TICRATE/3)), 0), 0, v.height()*FU) -- more math
	local ttlcrd = getPatch(v, "BLASTTCF")
	local vscale = FixedDiv(v.height(), ttlcrd.height)
	v.drawStretched(xpos, ypos, FixedDiv(v.width(), ttlcrd.width), FixedDiv(v.height(), ttlcrd.height), getPatch(v, "BLASTTCB"), V_NOSCALEPATCH|V_NOSCALESTART|V_PERPLAYER)
	
	local ttlcrdx = v.width()*FU/2-FixedMul(ttlcrd.width*FU/2, vscale)
	v.drawScaled(xpos+ttlcrdx, ypos, vscale, ttlcrd, V_NOSCALEPATCH|V_NOSCALESTART|V_PERPLAYER)
	
	-- level title
	-- gets the level title (and zone if NoZone isn't active) and draws it with my super kewl scaled drawing function yeay)
	
	-- todo: make the act number be on the proper place
	-- 		 i think thats all
	--		 future pacola here, DONE!!!!
	--		 no im not deleting this
	local lvlttl = mapheaderinfo[gamemap].lvlttl+" "+((mapheaderinfo[gamemap].levelflags & LF_NOZONE) and "" or "Zone")
	drawScaledLevelTitle(v, xpos+v.width()*FU/2, ypos+18*FixedDiv(v.height(), 200), FU-FU/3, lvlttl, V_NOSCALESTART|V_PERPLAYER)
	if mapheaderinfo[gamemap].actnum ~= 0
		v.drawScaled(xpos+ttlcrdx+55*vscale, ypos+42*vscale, vscale, getPatch(v, "BLASTTCACT"), V_NOSCALEPATCH|V_NOSCALESTART|V_PERPLAYER)
		drawBlastNum(v, xpos+ttlcrdx+75*vscale, ypos+40*vscale, vscale, mapheaderinfo[gamemap].actnum, V_NOSCALESTART|V_NOSCALEPATCH|V_PERPLAYER, "right", "BLASTACT")
	end
	
	-- lives part
	-- gets ur LIFEA0 sprite and uses the default one if u don't have LIFEA0
	-- also gets how many lives u have and displays that, duh
	-- correct num x = 140
	if p.lives ~= INFLIVES
		v.drawScaled(xpos+v.width()*FU-61*vscale, ypos+65*vscale, vscale, getPatch(v, "BLASTTCLIVES"), V_NOSCALEPATCH|V_NOSCALESTART|V_PERPLAYER)
		local patch, flip = skins[p.skin].sprites[SPR2_LIFE].numframes > 0 and v.getSprite2Patch(p.skin, SPR2_LIFE, false, A, 0) or v.getSpritePatch(SPR_TV1U, C, 0)
		flip = $ and V_FLIP or 0
		v.drawScaled(xpos+v.width()*FU-40*vscale+patch.leftoffset*vscale, ypos+72*vscale+patch.topoffset*vscale, vscale, patch, V_NOSCALESTART|V_NOSCALEPATCH|V_PERPLAYER|flip, v.getColormap(p.skin, p.skincolor))
		drawBlastNum(v, xpos+v.width()*FU-40*vscale+patch.leftoffset*vscale+2*vscale, ypos+75*vscale, vscale, p.lives, V_NOSCALEPATCH|V_NOSCALESTART|V_PERPLAYER)
	end
	
	-- todo: PLEASE FINISH THIS ALREADY
	--		 or im sleeping on the couch
	--							 -Pacola
	
	-- that thing above is a joke please spare me
	--									  -Pacola
	
	-- score part!!!
	-- scores ur score
	-- wat else would it do!!
	v.drawScaled(xpos+7*vscale, ypos+89*vscale, vscale, getPatch(v, "BLASTSCORE"), V_NOSCALESTART|V_NOSCALEPATCH|V_PERPLAYER)
	drawBlastNum(v, xpos+ttlcrdx+53*vscale, ypos+98*vscale, vscale, p.score, V_NOSCALESTART|V_NOSCALEPATCH|V_PERPLAYER, "left")
	
	-- Look!
	-- more messy code!
	v.drawScaled(xpos+8*vscale, ypos+56*vscale, vscale, getPatch(v, "BLASTLOOK"+(tics/8)%2), V_NOSCALESTART|V_NOSCALEPATCH|V_PERPLAYER)
	
	-- time
	-- shows 10 if there's no time limit
	-- shows actual time limit if there is one
	-- that's all
	v.drawScaled(xpos+v.width()*FU-61*vscale, ypos+89*vscale, vscale, getPatch(v, "BLASTTCTIME"), V_NOSCALEPATCH|V_NOSCALESTART|V_PERPLAYER)
	local cntdwn = getCountdown(p, true)
	local time = cntdwn ~= 0 and max(G_TicsToMinutes(cntdwn, true), 1) or 10
	-- countdown is in seconds, multiply it by TICRATE and we have a tics value, use G_TicsToMinutes to get a value in minutes, with a min of 1 minute because i dont wanna show seconds grrr
	local minpos = xpos+v.width()*FU-25*vscale-7*vscale
	v.drawScaled(minpos, ypos+113*vscale, vscale, getPatch(v, "BLASTMIN"), V_NOSCALESTART|V_NOSCALEPATCH|V_PERPLAYER)
	drawBlastNum(v, minpos-5*vscale, ypos+98*vscale, vscale, time, V_NOSCALESTART|V_NOSCALEPATCH|V_PERPLAYER)
end, "titlecard")

-- intermission stuff below
-- a.k.a act clear stuff

-- variables
local onintermission = false -- i need this bud
local inttics = 0
local ringbonus, timebonus, guardbonus, fakescore, charstuff
local spinbtn = false

addHook("ThinkFrame", function()
	hud.disable("score") -- these are here because
	hud.disable("time") -- some lua could enable them
	hud.disable("rings") -- and we don't want that
	hud.disable("lives") -- do we?
	hud.disable("stagetitle") -- that's what i thought
	hud.disable("intermissiontally") -- insert another message
	--hud.disable("intermissiontitletext")
	
	if consoleplayer then -- if you're the main player then
		onintermission = false -- reset the local (they are client-sided too) variables
		inttics = 0
		--ringsval = consoleplayer.rings
		spinbtn = false
		ringbonus = 0
		timebonus = 0
		guardbonus = 0
		charstuff = {
			tics = 0,
			x = 0
		}
		fakescore = consoleplayer.score
		
		musName = S_MusicName(consoleplayer):upper()
		if musName == "SBACTS"
		and S_GetMusicPosition() >= S_GetMusicLength()-5
			P_RestoreMusic(consoleplayer)
			S_SetMusicPosition(0)
		end
	end
end)

-- gets if you have spin held
-- so i can know when tf i have to skip the tallying
-- why couldn't they just give me a way to
-- get the bonuses being shown on the screen
-- would've made my job way easier
local function getSpin()
	local spinkey = {input.gameControlToKeyNum(GC_SPIN)}
	local spinHeld = false
	for _, v in ipairs(spinkey) do
		if gamekeydown[v] then spinHeld = true break end
	end
	
	if spinHeld then
		spinbtn = true
	else
		spinbtn = false
	end
end

-- use p.timeshit to calculate guard bonus
-- use p.realtime to calculate the time bonus
-- p.rings*100 = ring bonus, just like the sprite says!!
-- talling starts at about 40 tics

local timescore = { -- table containing the scores related to a certain time in seconds
	[29] = 50000,
	[59] = 10000,
	[90] = 5000,
	[60+59] = 4000,
	[60*2+59] = 3000,
	[60*3+59] = 2000,
	[60*4+59] = 1000,
	[60*5+59] = 500,
	[60*6+59] = 400,
	[60*7+59] = 300,
	[60*8+59] = 200,
	[60*9+59] = 100
}

local guardscore = {
	[0] = 10000,
	[1] = 5000,
	[2] = 1000,
	[3] = 500,
	[4] = 100
}

local function getTimeScore(value)
	local rvalue
	if value <= 60*9+59
		local i = 0
		while timescore[value+i] == nil do
			if value+i > 60*9+59 then break end
			
			i = $+1
		end
		rvalue = timescore[value+i]
	end
	rvalue = $ ~= nil and $ or 0
	
	return rvalue
end

-- i would make the character thing customizable
-- but let's be honest, who tf is adding support
-- for the fucking sonic blast hud? (me obviously)
--							-Pacola
--			 (who else would it be)

local function IsSpecialStage(mapnum) -- unnecessarily translate G_IsSpecialStage to lua, because why not?
	mapnum = $ ~= nil and $ or gamemap
	if (modeattacking)
		return false;
	end
	
	if (mapnum >= sstage_start and mapnum <= sstage_end)
		return true;
	end
	
	if (mapnum >= smpstage_start and mapnum <= smpstage_end)
		return true;
	end

	return false;
end

addHook("IntermissionThinker", function()
	onintermission = true
	inttics = $+1
end)

addHook("HUD", function(v)
	if netgame and not G_CoopGametype() then return end -- if you're in multiplayer and aren't on a coop gametype then i dont feel like showing
	
	local shouldchange = not paused and (netgame or not menuactive)
	
	/*onintermission = true -- you are on the intermission
	if shouldchange
		inttics = $+1 -- what a way to figure out tics
	end*/
	
	local p = consoleplayer
	local lh = mapheaderinfo[gamemap] -- lh stands for level header
	local vscale = FixedDiv(v.height(), 140)-- he is back
	local intx = v.width()*FU/2-FixedMul(160*FU/2, vscale)
	
	-- calculate the stuff
	local tallystart = IsSpecialStage() and 2*TICRATE or TICRATE
	local ended = false
	if inttics > tallystart
	and shouldchange
		local timeval = getTimeScore(p.realtime/TICRATE)
		local guardval = (guardscore[p.timeshit] ~= nil and guardscore[p.timeshit] or 0) -- i love time shit
		
		local oringbonus, otimebonus, oguardbonus = ringbonus, timebonus, guardbonus
		local ringlimit = p.rings*100
		if (lh.typeoflevel & TOL_NIGHTS) then
			ringlimit = p.recordscore -- i dont want to craete anothr val, i should've done this with time and guard too
		end
		ringbonus = min($+222, ringlimit)
		timebonus = min($+222, timeval)
		guardbonus = min($+222, guardval)
		
		local fakeadd = 0
		if bonustype ~= -1
		and oringbonus ~= ringbonus
			fakeadd = $+1
		end
		
		if bonustype == 0
		and otimebonus ~= timebonus
			fakeadd = $+1
		elseif bonustype ~= -1
		and oguardbonus ~= guardbonus
			fakeadd = $+1
		end
		fakeadd = max($, 1)
		fakescore = min($+222*fakeadd, p.score)
		
		if spinbtn
			ringbonus = ringlimit
			timebonus = timeval
			guardbonus = guardval
			fakescore = p.score
		end
	end
	
	if fakescore == p.score
		ended = true
	end
	
	if not IsSpecialStage()
		local bonustype = lh.bonustype
		/*	-1 = None
			0 = Normal
			1 = Boss
			2 = ERZ3	*/
		
		-- 160, 140
		v.drawStretched(0, 0, FixedDiv(v.width(), 160), vscale, getPatch(v, "BLASTINTB"), V_NOSCALEPATCH|V_NOSCALESTART)
		v.drawScaled(intx, 0, vscale, getPatch(v, "BLASTINTF"), V_NOSCALEPATCH|V_NOSCALESTART)
		
		-- You Got Through!!
		v.drawScaled(8*vscale, 8*vscale, vscale, getPatch(v, "BLASTINTGT"), V_NOSCALEPATCH|V_NOSCALESTART)
		
		-- Act part
		-- shows the act
		if lh.actnum ~= 0
			v.drawScaled(intx+95*vscale, 26*vscale, vscale, getPatch(v, "BLASTINTACT"), V_NOSCALEPATCH|V_NOSCALESTART)
			drawBlastNum(v, intx+120*vscale, 25*vscale, vscale, (mapheaderinfo[gamemap].actnum ~= 0 and mapheaderinfo[gamemap].actnum or nil), V_NOSCALESTART|V_NOSCALEPATCH|V_PERPLAYER, "right", "BLASTACT")
		end
		
		-- ring bonus!!
		-- calculates the ring bonus stuff idk yeay!!
		if bonustype ~= -1 -- only show if the ring bonus exists, which it only doesnt exist in None!
			v.drawScaled(8*vscale, 49*vscale, vscale, getPatch(v, "BLASTRINGB"), V_NOSCALEPATCH|V_NOSCALESTART)
			drawBlastNum(v, v.width()*FU-44*vscale, 49*vscale, vscale, ringbonus, V_NOSCALEPATCH|V_NOSCALESTART, "left", "BLASTINT")
		end
		
		-- time bonus!!!
		-- and also guard bonus
		if bonustype == 0 -- time bonus is inside here!!!
			v.drawScaled(8*vscale, 65*vscale, vscale, getPatch(v, "BLASTTIMEB"), V_NOSCALEPATCH|V_NOSCALESTART)
			drawBlastNum(v, v.width()*FU-44*vscale, 65*vscale, vscale, timebonus, V_NOSCALEPATCH|V_NOSCALESTART, "left", "BLASTINT")
		elseif bonustype ~= -1 -- while the guard bonus is in here!!
			v.drawScaled(8*vscale, 65*vscale, vscale, getPatch(v, "BLASTGUARDB"), V_NOSCALEPATCH|V_NOSCALESTART)
			drawBlastNum(v, v.width()*FU-44*vscale, 65*vscale, vscale, guardbonus, V_NOSCALEPATCH|V_NOSCALESTART, "left", "BLASTINT")
		end
		
		-- display ur current score!
		v.drawScaled(8*vscale, 80*vscale, vscale, getPatch(v, "BLASTINTSCORE"), V_NOSCALESTART|V_NOSCALEPATCH)
		drawBlastNum(v, v.width()*FU-44*vscale, 80*vscale, vscale, fakescore, V_NOSCALEPATCH|V_NOSCALESTART, "left", "BLASTINT")
		
		-- displays ur lives, if u have them
		if p.lives ~= INFLIVES
			v.drawScaled(intx+48*vscale, 97*vscale, vscale, getPatch(v, "BLASTINTX"), V_NOSCALESTART|V_NOSCALEPATCH)
			drawBlastNum(v, intx+54*vscale+(8*3)*vscale, 96*vscale, vscale, p.lives, V_NOSCALESTART|V_NOSCALEPATCH, "left", "BLASTINT")
		end
		
		-- character stuff
		local spd = 6*FU
		local ocharpos = charstuff.x
		local sprite = {S_PLAY_RUN, SPR2_RUN_, 7}
		local fsprite = {SPR2_TAL6, 3, -10}
		local maxx = ended and v.width()*2*FU or intx+39*vscale
		--local maxx = ended and v.width()*2*FU or intx+25*vscale
		if inttics > tallystart/2
		and shouldchange
			charstuff.x = $+FixedMul(spd, vscale)
		end
		charstuff.x = min($, maxx)
		
		if charstuff.x == ocharpos
			sprite = {S_PLAY_STND, SPR2_STND, 8}
			fsprite = {SPR2_TAL0, 5, 0}
		end
		
		local maxframe = sprite[2] ~= SPR2_STND and skins[p.skin].sprites[sprite[2]].numframes or 1
		while maxframe == nil or maxframe <= 0 do
			sprite[2] = spr2defaults[$]
			maxframe = skins[p.skin].sprites[sprite].numframes
		end
		
		local animtics = (states[sprite[1]].frame & FF_ANIMATE) and states[sprite[1]].var2 or states[sprite[1]].tics
		local patch, flip = v.getSprite2Patch(p.skin, sprite[2], false, (inttics/animtics)%maxframe, sprite[3])
		flip = $ and V_FLIP or 0
		
		if skins[p.skin].followitem == MT_TAILSOVERLAY -- i doubt it correctly works for every character but eh
			local maxtics = skins[p.skin].sprites[fsprite[1]].numframes
			local fpatch, fflip = v.getSprite2Patch(p.skin, fsprite[1], false, (inttics/fsprite[2])%maxtics, sprite[3])
			fflip = $ and V_FLIP or 0
			v.drawScaled(fsprite[3]*vscale+fpatch.leftoffset*(vscale/2)+charstuff.x-fpatch.width*(vscale/2), 131*vscale, vscale/2, fpatch, V_NOSCALESTART|V_NOSCALEPATCH|fflip, v.getColormap(p.skin, p.skincolor))
		end
		
		v.drawScaled(patch.leftoffset*(vscale/2)+charstuff.x-patch.width*(vscale/2), 131*vscale, vscale/2, patch, V_NOSCALESTART|V_NOSCALEPATCH|flip, v.getColormap(p.skin, p.skincolor))
	else
		v.drawFill(0, 0, v.width(), v.height(), 80|V_NOSCALESTART|V_NOSCALEPATCH)
		v.drawScaled(intx, 0, vscale, getPatch(v, "BLASTCEBG"), V_NOSCALESTART|V_NOSCALEPATCH)
		
		-- ring bonus/nights score bonus
		-- nights score bonus still shows Rings X 100, i'm lazy give me a break
		-- thsi is the 4th day that i'm working this in a row
		local bonusgfx = "BLASTCERNGBNS"
		--if (lh.typeoflevel & TOL_NIGHTS) then bonusgfx = "BLASTCENGTBNS" end -- changes the gfx to the nights one, todo: actually make one
		v.drawScaled(8*vscale, 99*vscale, vscale, getPatch(v, bonusgfx), V_NOSCALESTART|V_NOSCALEPATCH)
		drawBlastNum(v, v.width()*FU-11*vscale, 101*vscale, vscale, ringbonus, V_NOSCALESTART|V_NOSCALEPATCH, "left")
		
		-- score thing
		v.drawScaled(8*vscale, 123*vscale, vscale, getPatch(v, "BLASTCESCRBNS"), V_NOSCALESTART|V_NOSCALEPATCH)
		drawBlastNum(v, v.width()*FU-44*vscale, 125*vscale, vscale, fakescore, V_NOSCALESTART|V_NOSCALEPATCH, "left")
		v.drawScaled(v.width()*FU-32*vscale, 125*vscale, vscale, getPatch(v, "BLASTCEPTS"), V_NOSCALESTART|V_NOSCALEPATCH)
		
		for i = 1, 7 do
			if not (emeralds & _G["EMERALD"+i]) then continue end
			
			local x, y
			if i < 5
				x = 24*vscale+(16+14)*(i-1)*vscale
				y = 64*vscale
			else
				x = 39*vscale+(16+14)*(i-5)*vscale
				y = 81*vscale
			end
			v.drawScaled(intx+x, y, vscale, getPatch(v, "BLASTEMERALD"+i), V_NOSCALESTART|V_NOSCALEPATCH)
		end
	end
	
	getSpin()
end, "intermission")